unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AGLClasses, AGLObjects, ComCtrls, Buttons, ToolWin, ExtCtrls, Menus, AGLFiles,
  StdCtrls;

type
  TForm1 = class(TForm)
    AGLPanel1: TAGLPanel;
    ToolBar1: TToolBar;
    SelectSB: TSpeedButton;
    ToolButton1: TToolButton;
    TruckSB: TSpeedButton;
    PanSB: TSpeedButton;
    OrbitSB: TSpeedButton;
    RollSB: TSpeedButton;
    ToolButton2: TToolButton;
    DollySB: TSpeedButton;
    FOVSB: TSpeedButton;
    PerspSB: TSpeedButton;
    ResetSB: TSpeedButton;
    ToolButton3: TToolButton;
    Scene: TAGLScene;
    Camera: TAGLCamera;
    DXFConverter1: TDXFConverter;
    OpenDialog1: TOpenDialog;
    Root: TAGLActor;
    AGLLight1: TAGLLight;
    SaveButton: TButton;
    LoadButton: TButton;
    SaveDialog1: TSaveDialog;
    procedure TruckSBClick(Sender: TObject);
    procedure AGLActor1Action(Sender: TAGLObject; Time: Double);
    procedure LoadButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.TruckSBClick(Sender: TObject);
var
  mm: TAGLMouseMode;
begin
  mm := AGLPanel1.PanelControl.MouseLeft;

  if Sender = SelectSB then mm := mmSelect;

  if Sender = TruckSB then mm := mmTruck;
  if Sender = PanSB then mm := mmPan;
  if Sender = OrbitSB then mm := mmOrbit;
  if Sender = RollSB then mm := mmRoll;

  if Sender = DollySB then mm := mmDolly;
  if Sender = FOVSB then mm := mmFOV;
  if Sender = PerspSB then mm := mmPerspective;

  if Sender = ResetSB then AGLPanel1.Camera.Reset;

  AGLPanel1.PanelControl.MouseLeft := mm;
end;

procedure TForm1.AGLActor1Action(Sender: TAGLObject; Time: Double);
begin
  Sender.XForm.mRotate(0,0,0, 0,0,1, 5);
end;

procedure TForm1.LoadButtonClick(Sender: TObject);
var
  ext: string;
begin
  if OpenDialog1.Execute then
  begin
    ext := AnsiUpperCase(ExtractFileExt(OpenDialog1.FileName));
    if ext = '.DXF' then
    begin
      DXFConverter1.FileName := OpenDialog1.FileName;
      DXFConverter1.LoadFromFile;
    end else
    if ext = '.AGB' then
    begin
      Root.LoadFromFile(OpenDialog1.FileName);
    end else
      Root.LoadFromTextFile(OpenDialog1.FileName);
  end;
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
var
  ext: string;
begin
  if SaveDialog1.Execute then
  begin
    ext := AnsiUpperCase(ExtractFileExt(SaveDialog1.FileName));
    if ext = '.DXF' then
    begin
      DXFConverter1.FileName := SaveDialog1.FileName;
      DXFConverter1.SaveToFile;
    end else
    if ext = '.AGB' then
    begin
      Root.SaveToFile(SaveDialog1.FileName);
    end else
      Root.SaveToTextFile(SaveDialog1.FileName);
  end;
end;

end.
