unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, AGLClasses, AGLObjects, StdCtrls;

type
  TForm1 = class(TForm)
    AGLPanel1: TAGLPanel;
    AGLScene1: TAGLScene;
    Timer1: TTimer;
    Light: TAGLLight;
    Camera: TAGLCamera;
    Box: TAGLActor;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BoxAction(Sender: TAGLObject; Time: Double);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  cSize = 5;

procedure TForm1.FormCreate(Sender: TObject);

  function Lerp(c1, c2: TColor; d: single): TColor;
  var
    r,g,b: single;
  begin
    r := (GetRValue(c2)-GetRValue(c1))*d+GetRValue(c1);
    g := (GetGValue(c2)-GetGValue(c1))*d+GetGValue(c1);
    b := (GetBValue(c2)-GetBValue(c1))*d+GetBValue(c1);
    Result := RGB(round(r), round(g), round(b));
  end;

var
  x, y, z : Integer;
  cube : TAGLBox;
  factor, cubeSize : Single;
begin
  // bench only creation and 1st render (with lists builds, etc...)
  factor:=70/(cSize*2+1);
  cubeSize:=0.4*factor;
  AGLScene1.BeginUpdate;
  for x:=-cSize to cSize do
    for y:=-cSize to cSize do
      for z:=-cSize to cSize do
      begin
          cube := TAGLBox.Create(Form1);
          cube.SetParentComponent(Box);
          cube.XForm.Translate.X:=factor*x;
          cube.XForm.Translate.Y:=factor*y;
          cube.XForm.Translate.Z:=factor*z;
          cube.XForm.Scale.X:=cubeSize;
          cube.XForm.Scale.Y:=cubeSize;
          cube.XForm.Scale.Z:=cubeSize;
          cube.Color := Lerp(clYellow, clRed, (x*x+y*y+z*z)/(cSize*cSize*3));
      end;
  AGLScene1.EndUpdate;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Caption:=Format('%.2f FPS', [AGLPanel1.FFrame*1000/AGLPanel1.FTime]);
  AGLPanel1.FFrame := 0;
  AGLPanel1.FTime := 0;
end;

procedure TForm1.BoxAction(Sender: TAGLObject; Time: Double);
begin
  Sender.XForm.mRotate(0,0,0, 0,1,0, 5);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//  AGLScene1.SaveToTextFile('test.agl');
  AGLScene1.SaveToFile('test.agl');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//  AGLScene1.LoadFromTextFile('test.agl');
  AGLScene1.LoadFromFile('test.agl');
  AGLPanel1.Camera := TAGLCamera(AGLScene1.FindComponent('Camera'));
  TAGLActor(AGLScene1.FindComponent('Box')).OnAction := BoxAction;
end;

end.
